/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.ParamCostoTarjeta;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.ParamCostoTarjetaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.zkoss.zk.ui.Component;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;

/**
 *
 * @author Rafius
 */
@Controller("editarParamCostoTarjetaController")
@Scope("prototype")
public class EditarParamCostoTarjetaController extends MyGenericForwardComposer {

    @Autowired
    private ParamCostoTarjetaService paramCostoTarjetaService;
    @Autowired
    private EmpresaService empresaService;
    private List<Empresa> lsEmpresa;
    private BusquedaParamCostoTarjetaController busquedaParamCostoTarjetaController;
    private ParamCostoTarjeta paramCostoTarjeta;
    private MyListbox paramCostoTarjetaList;
    private static Logger log = Logger.getLogger(EditarParamCostoTarjetaController.class);
    private Combobox cmbEmpresa;
    private MyTextboxDecimal vlrInicial;
    private Button btnApagar;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsEmpresa =  UsuarioLogado.getUsuarioLogado().getEmpresa();

        super.doAfterCompose(comp);
        busquedaParamCostoTarjetaController = (BusquedaParamCostoTarjetaController) Executions.getCurrent().getArg().get("BusquedaParamCostoTarjetaController");
        paramCostoTarjeta = (ParamCostoTarjeta) Executions.getCurrent().getArg().get("paramCostoTarjeta");
        paramCostoTarjetaList = (MyListbox) Executions.getCurrent().getArg().get("paramCostoTarjetaList");

        if (paramCostoTarjeta.getParamcostotarjetaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        cmbEmpresa.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {

        cmbEmpresa.getSelectedItem().getValue();
        vlrInicial.getValue();

        paramCostoTarjeta.setActivo(true);
        paramCostoTarjeta.setFecmodif(Calendar.getInstance().getTime());
        paramCostoTarjeta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

        List<ParamCostoTarjeta> lsParam = paramCostoTarjetaService.buscar(paramCostoTarjeta);

        boolean podeSalvar = false;
        if (lsParam.isEmpty()) {
            podeSalvar = true;
        } else {
            if (paramCostoTarjeta.getParamcostotarjetaId() != null) {
                for (ParamCostoTarjeta p : lsParam) {
                    if (p.getParamcostotarjetaId().equals(paramCostoTarjeta.getParamcostotarjetaId())) {
                        podeSalvar = true;
                    }
                }
            }
        }

        if (podeSalvar) {
            if (paramCostoTarjeta.getParamcostotarjetaId() == null) {
                paramCostoTarjetaService.suscribir(paramCostoTarjeta);
                paramCostoTarjetaList.addItem(paramCostoTarjeta);
            } else {
                paramCostoTarjetaService.actualizacion(paramCostoTarjeta);
                paramCostoTarjetaList.updateItem(paramCostoTarjeta);
            }

            Messagebox.show(
                    Labels.getLabel("editarParamCostoTarjetaController.MSG.suscribirOK"),
                    Labels.getLabel("editarParamCostoTarjetaController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            closeWindow();
        } else {
            Messagebox.show(
                    Labels.getLabel("MSG.Registro.Existe"),
                    Labels.getLabel("editarParamCostoTarjetaController.window.title"),
                    Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarParamCostoTarjetaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarParamCostoTarjetaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                paramCostoTarjetaService.borrar(paramCostoTarjeta);

                Messagebox.show(
                        Labels.getLabel("editarParamCostoTarjetaController.MSG.borrarOK"),
                        Labels.getLabel("editarParamCostoTarjetaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                paramCostoTarjetaList.removeItem(paramCostoTarjeta);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public Combobox getCmbEmpresa() {
        return cmbEmpresa;
    }

    public void setCmbEmpresa(Combobox cmbEmpresa) {
        this.cmbEmpresa = cmbEmpresa;
    }

    public EmpresaService getEmpresaService() {
        return empresaService;
    }

    public void setEmpresaService(EmpresaService empresaService) {
        this.empresaService = empresaService;
    }

    public List<Empresa> getLsEmpresa() {
        return lsEmpresa;
    }

    public void setLsEmpresa(List<Empresa> lsEmpresa) {
        this.lsEmpresa = lsEmpresa;
    }

    public ParamCostoTarjeta getParamCostoTarjeta() {
        return paramCostoTarjeta;
    }

    public void setParamCostoTarjeta(ParamCostoTarjeta paramCostoTarjeta) {
        this.paramCostoTarjeta = paramCostoTarjeta;
    }

    public MyListbox getParamCostoTarjetaList() {
        return paramCostoTarjetaList;
    }

    public void setParamCostoTarjetaList(MyListbox paramCostoTarjetaList) {
        this.paramCostoTarjetaList = paramCostoTarjetaList;
    }

    public ParamCostoTarjetaService getParamCostoTarjetaService() {
        return paramCostoTarjetaService;
    }

    public void setParamCostoTarjetaService(ParamCostoTarjetaService paramCostoTarjetaService) {
        this.paramCostoTarjetaService = paramCostoTarjetaService;
    }
}
